<?php
namespace Claromentis\Infocapture\Controller\Rest;

$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"] ?: array()) + array("_f76b20cae22026c8464c782" . "43696de97" => base64_decode("aW5mb2NhcHR1cmUucmVzdC5ub19wcm9qZ" . "WN0"), "_c05f8f22b90692278db70d3" . "c304711e5" => base64_decode("aW5mb2NhcHR1cmUucmVz" . "dC5ub19wZXJtaXNzaW9u" . "X3Byb2plY3Q="), "_79bd87060993ff622ef21" . "2c1e8b6a79a" => base64_decode("Rm9y" . "Ymlk" . "ZGVu"), "_a4a1018258adabb74e7b04836d8d" . "7e3b" => base64_decode("Tm90I" . "EZvdW" . "5k"));
use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Http\ResponseFactory;
use Claromentis\Core\Localization\Lmsg;
use Claromentis\Infocapture\Exception\NotFoundException;
use Claromentis\Infocapture\Exception\PermissionException;
use Claromentis\Infocapture\Filter\ProjectFilter;
use Claromentis\Infocapture\RestFormatter;
use Claromentis\Core\Security\SecurityContext;
use Claromentis\Infocapture\Api;
use Psr\Http\Message\ServerRequestInterface;
class ProjectController
{
    protected Api $api;
    protected Lmsg $lmsg;
    protected RestFormatter $formatter;
    protected ResponseFactory $response;
    public function __construct(Api $api, RestFormatter $formatter, ResponseFactory $response, Lmsg $lmsg)
    {
        $this->api = $api;
        $this->formatter = $formatter;
        $this->response = $response;
        $this->lmsg = $lmsg;
    }
    
    
    
    
    
    
    
    
    
    
    public function getProject(SecurityContext $context, int $projectId) : JsonPrettyResponse
    {
        try {
            $project = $this->api->getProject($context, $projectId);
        } catch (NotFoundException $_c35473364fa7a050299058f332ec29c1) {
            throw new \RestExNotFound(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f76b20cae22026" . "c8464c78243696d" . "e97"]), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_a4a1018258adabb" . "74e7b04836d8d7e3" . "b"], $_c35473364fa7a050299058f332ec29c1);
        } catch (PermissionException $_c35473364fa7a050299058f332ec29c1) {
            throw new \RestExForbidden(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_c05f8f22b90692278db70d3c304711e" . "5"]), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_79bd87060993ff622ef212c1e8b" . "6a79a"], $_c35473364fa7a050299058f332ec29c1);
        }
        return $this->response->GetJsonPrettyResponse($this->formatter->FormatProject($project));
    }
    
    
    
    
    
    
    
    
    
    public function getProjects(SecurityContext $context, ServerRequestInterface $request) : JsonPrettyResponse
    {
        $_03e9164d0a343b742df4793268b80767 = new ProjectFilter();
        $_03e9164d0a343b742df4793268b80767->fill($request);
        $_68680c984182bf7876b2bb0ab77ebe01 = $this->api->getProjects($context, $_03e9164d0a343b742df4793268b80767);
        $_264e8772c4dd469c7acd9dc850e932fa = $this->formatter->FormatProjects($_68680c984182bf7876b2bb0ab77ebe01);
        $total = $this->api->getProjectsCount($_03e9164d0a343b742df4793268b80767);
        $response = $this->formatter->Paginate($request, $_264e8772c4dd469c7acd9dc850e932fa, $_03e9164d0a343b742df4793268b80767->toArray(), $total);
        return $this->response->GetJsonPrettyResponse($response);
    }
}